`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date: 04/28/2020 09:32:08 PM
// Design Name: 
// Module Name: speaker
// Project Name: 
// Target Devices: 
// Tool Versions: 
// Description: 
// 
// Dependencies: 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
//////////////////////////////////////////////////////////////////////////////////


module Lab8_1(
    f_crystal, // clock from crystal
    rst_n, // active low reset
    audio_mclk, // master clock
    audio_lrck, // left-right clock
    audio_sck, // serial clock
    audio_sdin // serial audio data input
    );
    // I/O declaration
    input f_crystal; // clock from the crystal
    input rst_n; // active low reset
    output audio_mclk; // master clock
    output audio_lrck; // left-right clock
    output audio_sck; // serial clock
    output audio_sdin; // serial audio data input
    // Declare internal nodes
    wire [15:0] audio_left, audio_right;
    // Note generation
    note_gen Ung(
    .clk(f_crystal), // clock from crystal
    .rst_n(rst_n), // active low reset
    .note_div(22'd191571), // div for note generation
    .audio_left(audio_left), // left sound audio
    .audio_right(audio_right) // right sound audio
    );
    // Speaker controllor
    speaker_control Usc(
    .f_crystal(f_crystal), // clock from the crystal
    .rst_n(rst_n), // active low reset
    .audio_left(audio_left), // left channel audio data input
    .audio_right(audio_right), // right channel audio data input
    .audio_mclk(audio_mclk), // master clock
    .audio_lrck(audio_lrck), // left-right clock
    .audio_sck(audio_sck), // serial clock
    .audio_sdin(audio_sdin) // serial audio data input
    );
endmodule
